=== debian/changelog ===
libzstd (1.5.6+dfsg-2) unstable; urgency=medium

  * Fix the udeb install location: install files into /usr/lib, not
    into /lib. Do that using an executable libzstd1-udeb.install file that
    only grabs the usr/lib/ parts of the libzstd1.install one.
  * Add a patch to fix the test suite on hurd-amd64. Closes: #1086343

 -- Peter Pentchev <roam@debian.org>  Mon, 30 Dec 2024 03:16:50 +0200
