=== debian/watch ===
version=4

opts="searchmode=plain,repacksuffix=+dfsg,dversionmangle=s/\+dfsg\d*//g,repack,compression=xz,pgpsigurlmangle=s/$/.sig/" \
  https://api.github.com/repos/facebook/zstd/releases https://github.com/[^"']*/zstd-(\d[\d.]+)@ARCHIVE_EXT@
