## libzstd 1.5.7+dfsg

=== debian/control ===
--- 
+++ 
@@ -1,29 +1,33 @@
 Source: libzstd
 Maintainer: RPM packaging team <team+pkg-rpm@tracker.debian.org>
-Uploaders: Peter Pentchev <roam@debian.org>
+Uploaders:
+ Peter Pentchev <roam@debian.org>,
 Section: libs
 Priority: optional
-Build-Depends: cmake (>= 3.24~),
-               debhelper (>> 13.15.2~),
-               dh-package-notes,
-               dpkg-build-api (= 1),
-               help2man,
-               liblz4-dev,
-               liblzma-dev,
-               zlib1g-dev,
-               less <!nocheck>,
-               python3 <!nocheck>,
+Build-Depends:
+ debhelper (>> 13.15.2~),
+ dh-package-notes,
+ dpkg-build-api (= 1),
+ cmake,
+ help2man,
+ less <!nocheck>,
+ liblz4-dev,
+ liblzma-dev,
+ python3 <!nocheck>,
+ zlib1g-dev,
 X-DH-Compat: 14
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/pkg-rpm-team/libzstd
 Vcs-Git: https://salsa.debian.org/pkg-rpm-team/libzstd.git
 Homepage: https://github.com/facebook/zstd
+X-Style: black
 
 Package: libzstd-dev
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libzstd1 (= ${binary:Version}),
+Depends:
+ libzstd1 (= ${binary:Version}),
 Description: fast lossless compression algorithm -- development files
  Zstd, short for Zstandard, is a fast lossless compression algorithm, targeting
  real-time compression scenarios at zlib-level compression ratio.
