=== debian/rules ===
--- 
+++ 
@@ -17,14 +17,14 @@
 HELP2MAN = help2man --no-info --help-option="'-h'" --no-discard-stderr
 mandir := $(CURDIR)/debian/zstd/usr/share/man/man1
 
-DH_AUTO_CONFIGURE_OPTS := \
+DH_CMAKE_CONFIGURE_OPTS := \
 	-DCMAKE_LIBRARY_ARCHITECTURE=${DEB_HOST_MULTIARCH} \
 	-DZSTD_LEGACY_SUPPORT:BOOL=ON \
 
 ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	DH_AUTO_CONFIGURE_OPTS += -DBUILD_TESTING:BOOL=OFF
+	DH_CMAKE_CONFIGURE_OPTS += -DBUILD_TESTING:BOOL=OFF
 else
-	DH_AUTO_CONFIGURE_OPTS += -DBUILD_TESTING:BOOL=ON
+	DH_CMAKE_CONFIGURE_OPTS += -DBUILD_TESTING:BOOL=ON
 endif
 
 ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
